#!/usr/bin/python
# -*- coding: utf-8 -*- 
import httplib2
import string
from datetime import datetime, timedelta
import time
import pytz
from xml.dom.minidom import parse, parseString

class Newegg_call():
    
    RequestData = "<xml />"
    Method ="POST"
    Versionno = '305'
    
    Authorization='bffc1c9051cae67f84e612455626f9ca'
    SellerID =''
    Secretkey=''
    
    def GenerateHeaders(self,Authorization,Secretkey):
        headers = {
                   "content-type": 'application/xml',
                   'Authorization': Authorization,
                   'Secretkey':Secretkey,
                   'Accept': 'application/xml'
                        }
        return headers

    def MakeCall(self,url):
        h = httplib2.Http(".cache",disable_ssl_certificate_validation=True)
        resp, content = h.request(url, self.Method, self.RequestData, self.GenerateHeaders(self.Authorization,self.Secretkey) )
        return content
    
def get_order_list(Secretkey,SellerID,From_time,To_time,pageIndex,pageSize,Status,Type):
   
    api = Newegg_call()
    
    api.Method = "PUT"
    api.Secretkey = Secretkey
    api.SellerID = SellerID
    
    url = "https://api.newegg.com/marketplace/ordermgmt/order/orderinfo?sellerid=%(SellerID)s&version=%(versionno)s" % {'SellerID':api.SellerID,'versionno':305}
    api.RequestData = """
    <NeweggAPIRequest>
        <OperationType>GetOrderInfoRequest</OperationType>
        <RequestBody>
            <PageIndex>%(pageIndex)s</PageIndex>
            <PageSize>%(pageSize)s</PageSize>
            <RequestCriteria>
                <OrderDownloaded>%(Status)s</OrderDownloaded>
                <Type>%(Type)s</Type>
                <OrderDateFrom>%(From_time)s</OrderDateFrom>
                <OrderDateTo>%(To_time)s</OrderDateTo>

            </RequestCriteria>
        </RequestBody>
    </NeweggAPIRequest>
        """
    api.RequestData = api.RequestData %{
                                        'Status':Status,
                                        'Type':Type,
                                        'From_time':From_time,
                                        'To_time':To_time,
                                        'pageIndex':pageIndex,
                                        'pageSize':pageSize
                                                    }
    responseDOM = api.MakeCall(url)
    responset = """
    <?xml version="1.0" encoding="utf-8"?>
    <NeweggAPIResponse>
        <IsSuccess>true</IsSuccess>
        <SellerID>A006</SellerID>
        <OperationType>GetOrderInfoResponse</OperationType>
        <ResponseBody>
            <PageInfo>
                <TotalCount>2</TotalCount>
                <TotalPageCount>1</TotalPageCount>
                <PageSize>10</PageSize>
                <PageIndex>1</PageIndex>
            </PageInfo>
            <OrderInfoList>
                <OrderInfo>
                    <SellerID>A006</SellerID>
                    <OrderNumber>41473642</OrderNumber>
                    <InvoiceNumber>0</InvoiceNumber>
                    <OrderDownloaded>true</OrderDownloaded>
                    <OrderDate>1/23/2012 7:33:05</OrderDate>
                    <OrderStatus>4</OrderStatus>
                    <OrderStatusDescription>Voided</OrderStatusDescription>
                    <CustomerName>WY SD</CustomerName>
                    <CustomerPhoneNumber>123-223-3223</CustomerPhoneNumber>
                    <CustomerEmailAddress>gdv6l0viwo4l7j1d@marketplace.newegg.com</CustomerEmailAddress>
                    <ShipToAddress1>149 Kenwood Dr</ShipToAddress1>
                    <ShipToAddress2 />
                    <ShipToCityName>Newcastle</ShipToCityName>
                    <ShipToStateCode>WY</ShipToStateCode>
                    <ShipToZipCode>82701</ShipToZipCode>
                    <ShipToCountryCode>USA</ShipToCountryCode>
                    <ShipService>Media Mail (7-14 business days)</ShipService>
                    <ShipToFirstName>WY</ShipToFirstName>
                    <ShipToLastName>SD</ShipToLastName>
                    <ShipToCompany />
                    <OrderItemAmount>0</OrderItemAmount>
                    <ShippingAmount>0.00</ShippingAmount>
                    <DiscountAmount>0.00</DiscountAmount>
                    <RefundAmount>0</RefundAmount>
                    <OrderTotalAmount>0.00</OrderTotalAmount>
                    <OrderQty>1</OrderQty>
                    <IsAutoVoid>true</IsAutoVoid>
                    <SalesChannel>0</SalesChannel>
                    <FulfillmentOption>1</FulfillmentOption>
                    <ItemInfoList>
                        <ItemInfo>
                        <SellerPartNumber>A00655467241</SellerPartNumber>
                        <NeweggItemNumber>9SIA0060823129</NeweggItemNumber>
                        <MfrPartNumber>55467241</MfrPartNumber>
                        <UPCCode />
                        <Description>test creation test item</Description>
                        <OrderedQty>1</OrderedQty>
                        <ShippedQty>0</ShippedQty>
                        <UnitPrice>1.00</UnitPrice>
                        <ExtendUnitPrice>1.03</ExtendUnitPrice>
                        <UnitShippingCharge>1.03</UnitShippingCharge >
                        <ExtendShippingCharge>1.03</ExtendShippingCharge>
                        <Status>3</Status>
                        <StatusDescription>Canceled</StatusDescription>
                        </ItemInfo>
                    </ItemInfoList>
                    <PackageInfoList />
                </OrderInfo>
                <OrderInfo>
                    <SellerID>A006</SellerID>
                    <OrderNumber>159243598</OrderNumber>
                    <InvoiceNumber>82961992</InvoiceNumber>
                    <OrderDownloaded>true</OrderDownloaded>
                    <OrderDate>1/18/2012 1:05:18</OrderDate>
                    <OrderStatus>3</OrderStatus>
                    <OrderStatusDescription>Invoiced</OrderStatusDescription>
                    <CustomerName>WY SD</CustomerName>
                    <CustomerPhoneNumber>123-223-3223</CustomerPhoneNumber>
                    <CustomerEmailAddress>gdv6l0viwo4l7j1d@marketplace.newegg.com</CustomerEmailAddress>
                    <ShipToAddress1>149 Kenwood Dr</ShipToAddress1>
                    <ShipToAddress2 />
                    <ShipToCityName>Newcastle</ShipToCityName>
                    <ShipToStateCode>WY</ShipToStateCode>
                    <ShipToZipCode>82701</ShipToZipCode>
                    <ShipToCountryCode>USA</ShipToCountryCode>
                    <ShipService>Media Mail (7-14 business days)</ShipService>
                    <ShipToFirstName>WY</ShipToFirstName>
                    <ShipToLastName>SD</ShipToLastName>
                    <ShipToCompany />
                    <OrderItemAmount>2.00</OrderItemAmount>
                    <ShippingAmount>10.00</ShippingAmount>
                    <DiscountAmount>1.00</DiscountAmount>
                    <RefundAmount>0</RefundAmount>
                    <OrderTotalAmount>11.00</OrderTotalAmount>
                    <OrderQty>2</OrderQty>
                    <IsAutoVoid>false</IsAutoVoid>
                    <SalesChannel>0</SalesChannel>
                    <FulfillmentOption>1</FulfillmentOption>
                    <ItemInfoList>
                        <ItemInfo>
                        <SellerPartNumber>A006ZX-35833</SellerPartNumber>
                        <NeweggItemNumber>9SIA0060845543</NeweggItemNumber>
                        <MfrPartNumber>ZX-35833</MfrPartNumber>
                        <UPCCode>431573000287</UPCCode>
                        <Description>GYRO Huge Metal Goliath 3.5CH Electric RTF RC Helicopter</Description>
                        <OrderedQty>2</OrderedQty>
                        <ShippedQty>2</ShippedQty>
                        <UnitPrice>1.00</UnitPrice>
                        <Status>2</Status>
                        <StatusDescription>Shipped</StatusDescription>
                        <ExtendUnitPrice>1.03</ExtendUnitPrice>
                        <UnitShippingCharge>1.03</UnitShippingCharge>
                        <ExtendShippingCharge>1.03</ExtendShippingCharge>
                        </ItemInfo>
                    </ItemInfoList>
                    <PackageInfoList>
                        <PackageInfo>
                            <PackageType>Shipped</PackageType>
                            <ShipCarrier>UPS</ShipCarrier>
                            <ShipService>342</ShipService>
                            <TrackingNumber>2342424</TrackingNumber>
                            <ShipDate>1/18/2012 16:59:15</ShipDate>
                            <ShipFromAddress>17708 rowland st</ShipFromAddress>
                            <ShipFromAddress2>this is test number</ShipFromAddress2>
                            <ShipFromCity>RP</ShipFromCity>
                            <ShipFromState>CA</ShipFromState>
                            <ShipFromZipCode>90001</ShipFromZipCode>
                            <ShipFromName>USA</ShipFromName>
                            <ItemInfoList>
                                <ItemInfo>
                                    <SellerPartNumber>A006ZX-35833</SellerPartNumber>
                                    <MfrPartNumber>ZX-35833</MfrPartNumber>
                                    <ShippedQty>2</ShippedQty>
                                </ItemInfo>
                            </ItemInfoList>
                        </PackageInfo>
                    </PackageInfoList>
                </OrderInfo>
            </OrderInfoList>
        </ResponseBody>
        <Memo />
    <ResponseDate>2/22/2012 16:51:03</ResponseDate>
    </NeweggAPIResponse>

        """
    
    try:
        responseDOM = parseString(responseDOM)
        return responseDOM
    except Exception, e:
        print 'get_order_list error',str(e)


#用来测试是否成功链接的
def get_service_status(Secretkey,SellerID):
    
    api = Newegg_call()        
    api.Method ="GET"
    api.Secretkey = Secretkey
    api.SellerID = SellerID
    url = 'https://api.newegg.com/marketplace/ordermgmt/servicestatus?sellerid=%(SellerID)s' % {'SellerID':api.SellerID}

    responseDOM = api.MakeCall(url)
    responseDOM = parseString(responseDOM)
    return responseDOM



#目前还不清楚这两个是不是类似的，是不是都是更新状态的，需要等fyan得到key之后才能知道到底使用那个

def update_order_status(Secretkey,SellerID,Order_map):
    api = Newegg_call()
    api.Secretkey = Secretkey
    api.SellerID = SellerID
    
    url = 'https://api.newegg.com/marketplace/ordermgmt/orderstatus/orders/%(OrderNumber)s?sellerid=%(SellerID)s&version=%(versionno)s' % {'OrderNumber':Order_map.OrderNumber,'SellerID':api.SellerID,'versionno':304}
    api.Method = "PUT"
#    Cancel Order
    if Order_map.status is 'Cancel':
        api.RequestData = """
            <UpdateOrderStatus>
                <Action>1</Action>
                <Value>24</Value>
            </UpdateOrderStatus>
            """
    else:
    #ship order
        api.RequestData = """
        <UpdateOrderStatus>
            <Action>2</Action>
            <Value>
            <![CDATA[
                <Shipment>
                    <Header>
                        <SellerID>%(SellerID)s</SellerID>
                        <SONumber>%(SONumber)s</SONumber>
                    </Header>
                    <PackageList>
                        <Package>
                            <TrackingNumber>%(TrackingNumber)s</TrackingNumber>
                            <ShipCarrier>%(ShipCarrier)s</ShipCarrier>
                            <ShipService>%(ShipService)s</ShipService>
                            <ItemList>
                                <Item>
                                    <SellerPartNumber>%(SellerPartNumber)s</SellerPartNumber>
                                    <ShippedQty>%(ShippedQty)s</ShippedQty>
                                </Item>
                            </ItemList>
                        </Package>
                    </PackageList>
                </Shipment>
                        ]]>
            </Value>
        </UpdateOrderStatus>
        """
    #void order
    repuset = """
    <?xml version="1.0" encoding="utf-8"?>
    <UpdateOrderStatusInfo>
        <IsSuccess>true</IsSuccess>
        <Result>
            <OrderNumber>159243598</OrderNumber>
            <SellerID>A006</SellerID>
            <OrderStatus>Void</OrderStatus>
        </Result>
    </UpdateOrderStatusInfo>
        """
    #ship order
    request = """
    <?xml version="1.0" encoding="utf-8"?>
    <UpdateOrderStatusInfo>
        <IsSuccess>true</IsSuccess>
        <PackageProcessingSummary>
            <TotalPackageCount>1</TotalPackageCount>
            <SuccessCount>1</SuccessCount>
            <FailCount>0</FailCount>
        </PackageProcessingSummary>
        <Result>
            <OrderNumber>159243598</OrderNumber>
            <SellerID>A006</SellerID>
            <OrderStatus>Shipped</OrderStatus>
            <Shipment>
                <PackageList>
                    <Package>
                        <TrackingNumber>lztestA0060001</TrackingNumber>
                        <ShipDate>2012-02-10T15:30:01</ShipDate>
                        <ProcessStatus>true</ProcessStatus>
                        <ProcessResult>Success</ProcessResult>
                        <ItemList>
                            <ItemDes>
                                <NeweggItemNumber>9SIA0060845543</NeweggItemNumber>
                                <SellerPartNumber>A006ZX-35833</SellerPartNumber>
                                <ShippedQty>1</ShippedQty>
                            </ItemDes>
                        </ItemList>
                    </Package>
                </PackageList>
            </Shipment>
        </Result>
    </UpdateOrderStatusInfo>
        """
    #error
    request = """
    <?xml version="1.0" encoding="utf-8"?>
    <Errors>
        <Error>
            <Code>SO002</Code>
            <Message>Order Number should be an integer (ranging from 1 to 2147483647)</Message>
        </Error>
    </Errors>

        """

def update_order_status_patch(Secretkey,SellerID,Order_map_list,bulk_list):
    
    api = Newegg_call()
    api.Method ="POST"
    api.Secretkey = Secretkey
    api.SellerID = SellerID
    url = 'https://api.newegg.com/marketplace/datafeedmgmt/feeds/submitfeed?sellerid=%(SellerID)s&requesttype=ORDER_SHIP_NOTICE_DATA' % {'SellerID':api.SellerID }
    api.RequestData = """
    <NeweggEnvelope xsi:noNamespaceSchemaLocation="ShipNotice.xsd" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
        <Header>
            <DocumentVersion>1.0</DocumentVersion>
        </Header>
        <MessageType>ShipNotice</MessageType>
        <Message>
            <ShipNotice>
            """
    
    for Order_map in Order_map_list:
        if bulk_list[Order_map['OrderNumber']]['status'] is True:
            continue
        bulk_list[Order_map['OrderNumber']]['status'] = True
        api.RequestData = api.RequestData + """
            <Package>
                <OrderNumber>%(OrderNumber)s</OrderNumber>
                <ItemInformation>
                    <Item>
                        <SellerPartNumber>%(SellerPartNumber)s</SellerPartNumber>
                        <ShippedQuantity>%(ShippedQuantity)s</ShippedQuantity>
                    </Item>
                </ItemInformation>
                <ShipDate>%(ShipDate)s</ShipDate>
                <ActualShippingCarrier>%(ActualShippingCarrier)s</ActualShippingCarrier>
                <ActualShippingMethod>%(ActualShippingMethod)s</ActualShippingMethod>
                <TrackingNumber>%(TrackingNumber)s</TrackingNumber>
                <ShippingFromInformation>
                    <ShippingFromAddress>%(ShippingFromAddress)s</ShippingFromAddress>
                    <ShippingFromCity>%(ShippingFromCity)s</ShippingFromCity>
                    <ShippingFromState>%(ShippingFromState)s</ShippingFromState>
                    <ShippingFromZipcode>%(ShippingFromZipcode)s</ShippingFromZipcode>
                    <PhoneNumber>%(PhoneNumber)s</PhoneNumber>
                </ShippingFromInformation>
            </Package>
                     """ 
        api.RequestData = api.RequestData   % {
                                        'OrderNumber':Order_map['OrderNumber'],
                                        'SellerPartNumber':Order_map['SellerPartNumber'],
                                        'ShippedQuantity':Order_map['ShippedQuantity'],
                                        'ShipDate':str(Order_map['ShipDate'])[0:19],
                                        'ActualShippingCarrier':Order_map['ActualShippingCarrier'],
                                        'ActualShippingMethod':Order_map['ActualShippingMethod'],
                                        'TrackingNumber':Order_map['TrackingNumber'],
                                        'ShippingFromAddress':Order_map['ShippingFromAddress'],
                                        'ShippingFromCity':Order_map['ShippingFromCity'],
                                        'ShippingFromState':Order_map['ShippingFromState'],
                                        'ShippingFromZipcode':Order_map['ShippingFromZipcode'],
                                        'PhoneNumber':Order_map['PhoneNumber'],
                                                    }
        
    api.RequestData = api.RequestData + """
            </ShipNotice>
        </Message>
    </NeweggEnvelope>
            """
    responseDOM = api.MakeCall(url)
    
    """
    <?xml version="1.0" encoding="utf-8"?>
    <NeweggAPIResponse>
        <IsSuccess>true</IsSuccess>
        <OperationType>SubmitFeedResponse</OperationType>
        <SellerID>A006</SellerID>
        <ResponseBody>
            <ResponseList>
                <ResponseInfo>
                    <RequestId>2291326430</RequestId>
                    <RequestType>ITEM_DATA</RequestType>
                    <RequestDate>2/16/2012 12:29:19</RequestDate>
                    <RequestStatus>SUBMITTED</RequestStatus>
                </ResponseInfo>
            </ResponseList>
        </ResponseBody>
        <Memo />
    </NeweggAPIResponse>

    
        """
   
    responseDOM = parseString(responseDOM)
    return responseDOM

def get_feed_status(Secretkey,SellerID,RequestID,RequestType):
    
    api = Newegg_call()        
    api.Method ="PUT"
    api.Secretkey = Secretkey
    api.SellerID = SellerID
    url = 'https://api.newegg.com/marketplace/datafeedmgmt/feeds/status?sellerid=%(SellerID)s' % {'SellerID':api.SellerID}

    api.RequestData = """
    <NeweggAPIRequest>
        <OperationType>GetFeedStatusRequest</OperationType>
        <RequestBody>
            <GetRequestStatus>
                <RequestIDList>
                    <RequestID>%(RequestID)s</RequestID>
                </RequestIDList>
                <RequestTypeList>
                    <RequestType>%(RequestType)s</RequestType>
                </RequestTypeList>
                <MaxCount>100</MaxCount>
                <RequestStatus>ALL</RequestStatus>
            </GetRequestStatus>
        </RequestBody>
    </NeweggAPIRequest>
        """
        
        
    api.RequestData = api.RequestData   % {
                                        'RequestID':RequestID,
                                        'RequestType':RequestType,
                                                    }
    responseDOM = api.MakeCall(url)
    responseDOM = parseString(responseDOM)
    return responseDOM
    """ 
     <?xml version="1.0" encoding="utf-8"?>
    <NeweggAPIResponse>
        <IsSuccess>true</IsSuccess>
        <OperationType>GetFeedStatusResponse</OperationType>
        <SellerID>A006</SellerID>
        <ResponseBody>
            <ResponseList>
                <ResponseInfo>
                    <RequestId>2PQCX3SPZ3QBF</RequestId>
                    <RequestType>ITEM_DATA</RequestType>
                    <RequestDate>2/22/2012 17:25:10</RequestDate>
                    <RequestStatus>FINISHED</RequestStatus>
                </ResponseInfo>
            </ResponseList>
        </ResponseBody>
    </NeweggAPIResponse>

        """

def get_feed_result(Secretkey,SellerID,RequestID,RequestType):    
    api = Newegg_call()        
    api.Method ="GET"
    api.SellerID = SellerID
    api.Secretkey = Secretkey
    

    url = 'https://api.newegg.com/marketplace/datafeedmgmt/feeds/result/%(RequestID)s?sellerid=%(SellerID)s' % {'RequestID':RequestID,'SellerID':api.SellerID}
    
    responseDOM = api.MakeCall(url)
    responseDOM = parseString(responseDOM)
    return responseDOM
    #return 
    """ 
    <?xml version="1.0" encoding="utf-8"?>
    <NeweggEnvelope>
        <Header>
            <DocumentVersion>1.0</DocumentVersion>
        </Header>
        <MessageType>ProcessingReport</MessageType>
        <Message>
            <ProcessingReport>
                <OriginalMessageName>APIAutoFile.xml</OriginalMessageName>
                <StatusCode>ProcessReport</StatusCode>
                <OriginalMessageType>ShipNotice</OriginalMessageType>
                <ProcessedStamp>2/7/2012 5:35:02 AM,PST</ProcessedStamp>
                <ProcessingSummary>
                    <ProcessedCount>1</ProcessedCount>
                    <SuccessCount>1</SuccessCount>
                    <WithErrorCount>0</WithErrorCount>
                </ProcessingSummary>
            </ProcessingReport>
        </Message>
    </NeweggEnvelope>

    """
    
def patch_sumbit_newegg(Secretkey,SellerID,Order_map_list):
    
    request_time1  = 0
    
    bulk_list ={}
    
    account_id = Order_map_list.keys()[0]
    Order_map_list = Order_map_list[account_id]
    
    while request_time1 < 1:
        
        request_time1 = request_time1 +1
        for each_map in Order_map_list:
            if bulk_list.get(each_map['OrderNumber']) is None:
                bulk_list[str(each_map['OrderNumber'])]  = {'status':False}
                
        status = update_order_status_patch(Secretkey,SellerID,Order_map_list,bulk_list)
        
        RequestID = status.getElementsByTagName("RequestId")[0].childNodes[0].data
        RequestType = status.getElementsByTagName("RequestType")[0].childNodes[0].data

        request_time2 = 0
        
        while  True and request_time2 < 15 :
            time.sleep(60) 
            feed_status = get_feed_status(Secretkey,SellerID,RequestID,RequestType)
            if feed_status.getElementsByTagName("RequestStatus")[0].childNodes[0].data == 'FINISHED':
                break
            else:
                request_time2 = request_time2 +1 

        dom = get_feed_result(Secretkey,SellerID,RequestID,RequestType)

        MessagesProcessed = dom.getElementsByTagName("ProcessedCount")[0].childNodes[0].data
        MessagesSuccessful = dom.getElementsByTagName("SuccessCount")[0].childNodes[0].data        
        
        if MessagesProcessed > MessagesSuccessful:
            for each in dom.getElementsByTagName("Result"):
                bulk_list[str(each.getElementsByTagName("OrderNumber")[0].childNodes[0].data)]['status'] = False
                bulk_list[str(each.getElementsByTagName("OrderNumber")[0].childNodes[0].data)]['ErrorDescription'] = each.getElementsByTagName("ErrorDescription")[0].childNodes[0].data
        else:
            break
    return bulk_list


def test():
    
#    Secretkey='ee3ec293-6e47-4d24-b135-0251f1f2d17e'
#    SellerID='A5KE'
#    From_time = '2014-07-10 09:30:47'
#    To_time = '2014-07-12 09:30:47'

    To_time = datetime.now(pytz.UTC)
    From_time = To_time - timedelta(days = 15)
    pageIndex= 1
    pageSize = 10
    status =4
    type =0
    
    Secretkey='03cdb69e-5096-484b-9710-bc8b4fa7de66'
    SellerID='A4YW'
    
    RequestID = '23VJK89M7RJZS'
    RequestType ='ORDER_SHIP_NOTICE_DATA'
    
    
    print 'start get feed status'
#    #feed_status = get_feed_status(Secretkey,SellerID,RequestID,RequestType)
#    dom = get_feed_result(Secretkey,SellerID,RequestID,RequestType)
#    print 'end'
#    print 'feed_status',dom
    
    dom = get_order_list(Secretkey,SellerID,str(From_time),str(To_time),pageIndex,pageSize,status,type)
    print 'end get order'
    print 'dom',dom
#    
#    print 'CustomerName',dom.getElementsByTagName('CustomerName')[0].childNodes[0].data

#test()

